From 51e81b20834d645ba7233b6813fa81c9558f686c Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 20 2020 03:22:53 +0000
Subject: [PATCH 1461/2232] Merge pull request #490 from dtolnay/externstruct


Skip ExternType::Kind check if type is known trivial
---

diff --git a/syntax/types.rs b/syntax/types.rs
index 92c9a75..f57b61b 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -170,7 +170,10 @@ impl<'a> Types<'a> {
         let mut required_trivial = Map::new();
         let mut insist_alias_types_are_trivial = |ty: &'a Type, reason| {
             if let Type::Ident(ident) = ty {
-                if cxx.contains(&ident.rust) {
+                if cxx.contains(&ident.rust)
+                    && !structs.contains_key(&ident.rust)
+                    && !enums.contains_key(&ident.rust)
+                {
                     required_trivial.entry(&ident.rust).or_insert(reason);
                 }
             }
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index c408fb0..032adc4 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -113,6 +113,7 @@ pub mod ffi {
     #[namespace = "second"]
     struct Second {
         i: i32,
+        e: COwnedEnum,
     }
 
     unsafe extern "C++" {

